
# import urllib

# p = {"cmd"           : "_cart",
#      "upload"        : "1",
#           ## TODO: put it on portal_ordermanager
#      "business"      : "gael@pilotsystems.net",
#      #     "email"         : "toto@example.com",
#      #     "first_name"    : "toto",
#      #     "last_name"     : "tutu",
#      #     "address1"      : "66 rue de provence",
#      #     "address2"      : "",
#      #     "zip"           : "75009",
#      #     "city"          : "Paris",
#      #     "state"         : "",
#      #     "country"       : "France",
#           ## TODO: hardcoded!
#      "currency_code" : "EUR",
#      "invoice"       : "12345",
#      "no_shipping"   : "1",
#      "return"        : 'http://dev.ens-colloque.pilotsystems.net/toto',
#      "cancal_return"        : 'http://dev.ens-colloque.pilotsystems.net/toto',
#      "notify_url"        : 'http://dev.ens-colloque.pilotsystems.net/toto',
#      'item_name_1' : 'Inscription',
#      'amount_1' : '11.00',
#      'quantity_1'  : '1'
#           }
# url = "https://www.sandbox.paypal.com/cgi-bin/webscr"

# param = []
# for k, v in p.items():
#       param.append("%s=%s" % (k, urllib.quote_plus(v)))
#       param = "&".join(param)

#       print "%s?%s" % (url, param)

from Products.CMFCore.utils import getToolByName, UniqueObject
from Products.CMFPlone.PropertiesTool import SimpleItemWithProperties
from AccessControl import ClassSecurityInfo
from Products.PythonScripts.standard import html_quote

from AccessControl import getSecurityManager
from AccessControl.SecurityManagement import newSecurityManager, setSecurityManager
from AccessControl.User import UnrestrictedUser as BaseUnrestrictedUser

from cStringIO import StringIO
from urllib import urlencode

import sha
import hmac
import random
import urllib
import md5
import urllib2
import base64

class UnrestrictedUser(BaseUnrestrictedUser):
    """Unrestricted user that still has an id."""
    def getId(self):
        """Return the ID of the user."""
        return self.getUserName() 

def gen_key():
    key=''
    for i in xrange(16):
        key += chr(random.randint(0,255))
    return key

class PaypalTool(UniqueObject, SimpleItemWithProperties):
    """
    This tool encapsulates paypal payment information.
    """

    plone_tool = 1
    meta_type = "CMF Paypal helper tool"
    id = "portal_paypal"
    title = "Paypal configuration"
    icon_file = 'paypal_tool_icon.gif'
    
    security = ClassSecurityInfo()

    manage_options =         SimpleItemWithProperties.manage_options

    def __init__(self, *args, **kwargs):
        """ Init tool properties """
        
        self._setProperty('paypal_url_scheme', 'https', 'string')
        self._setProperty('paypal_domain', 'www.sandbox.paypal.com', 'string')
        self._setProperty('paypal_path', '/cgi-bin/webscr', 'string')
        self._setProperty('paypal_account_email', 'account@example.com', 'string')
        self._setProperty('validate_script', 'validatePaypalPayment', 'string')
        self._setProperty('default_currency', 'EUR', 'string')
        self._setProperty('default_return_path', '/index_html?portal_status_message=Payment+accepted.', 'string')
        self._setProperty('default_cancel_path', '/index_html?portal_status_message=Payment+cancelled.','string')
        self._setProperty('paypal_button_image', 'http://www.paypal.com/en_US/i/btn/x-click-but01.gif','string')
        self._setProperty('paypal_button_alt',"Make payments with PayPal - it's fast, free and secure!",'string')
        self._setProperty('tool_key', base64.encodestring(gen_key()), 'string')

    security.declareProtected("Pay via paypal", "makePaypalButton")
    def makePaypalButton(self, currency=None, cart=[], invoice=None, return_url=None, cancel_url=None, custom=None):
        """ Create a paypal button. """

        portal = getToolByName(self, 'portal_url').getPortalObject()
        portal_url = portal.absolute_url().rstrip('/')

        paypal_account = html_quote(self.getProperty('paypal_account_email'))
        full_paypal_url = html_quote('%s://%s/%s' % (self.getProperty('paypal_url_scheme'),
                                                     self.getProperty('paypal_domain'),
                                                     self.getProperty('paypal_path').lstrip('/')))
        if not currency:
            currency = html_quote(self.getProperty('default_currency'))

        if not return_url:
            return_url = '%s/%s' % (portal_url, self.getProperty('default_return_path').lstrip('/'))
        return_url = html_quote(return_url)
        
        if not cancel_url:
            cancel_url = '%s/%s' % (portal_url, self.getProperty('default_cancel_path').lstrip('/'))
        cancel_url = html_quote(return_url)

        notify_url = html_quote('%s/paypal_notification' % self.absolute_url())
        
        button_url = html_quote(self.getProperty('paypal_button_image'))
        button_text = html_quote(self.getProperty('paypal_button_alt'))

        cart_form_fields = ''
        counter = 1
        for item_name, price, quantity in cart:
            cart_form_fields += """
            <input type="hidden" name="item_name_%(counter)d" value="%(name)s" />
            <input type="hidden" name="amount_%(counter)d" value="%(price).2f" />
            <input type="hidden" name="quantity_%(counter)d" value="%(quantity)d" />
            """ % {'counter':counter, 'name':html_quote(item_name), 'price':price, 'quantity':quantity}
            counter += 1
        if invoice:
            cart_form_fields += """<input type="hidden" name="invoice" value="%s" />""" % html_quote(str(invoice))
        if custom:
            cart_form_fields += """<input type="hidden" name="custom" value="%s" />""" % html_quote(str(custom))
        
        form = """
<form name="_xclick" method="post" action="%(full_paypal_url)s" >
<input type="hidden" name="cmd" value="_cart" />
<input type="hidden" name="upload" value="1" />
<input type="hidden" name="no_shipping" value="1" />
<input type="hidden" name="business" value="%(paypal_account)s" />
<input type="hidden" name="return" value="%(return_url)s" />
<input type="hidden" name="cancel_url" value="%(cancel_url)s" />
<input type="hidden" name="currency_code" value="%(currency)s" />
<input type="hidden" name="notify_url" value="%(notify_url)s" />
%(cart)s
<input type="image" src="%(button_url)s" border="0" name="submit" alt="%(button_text)s" />
</form>
""" % { 'cart':cart_form_fields,
        'full_paypal_url':full_paypal_url,
        'paypal_account':paypal_account,
        'currency':currency,
        'return_url':return_url,
        'cancel_url':cancel_url,
        'button_url':button_url,
        'notify_url':notify_url,
        'button_text':button_text }

        return form


    security.declarePublic('paypal_notification')
    def paypal_notification(self):
        """Receive a paypal notification"""

        portal = getToolByName(self, 'portal_url').getPortalObject()
        
        request = self.REQUEST

        # Fetch values
        invoice = request.form.get('invoice', '')
        custom = request.form.get('custom', '')
        email = request.form.get('receiver_email')
        account_email = self.getProperty('paypal_account_email')
        scheme = self.getProperty('paypal_url_scheme')
        domain = self.getProperty('paypal_domain')
        path = self.getProperty('paypal_path').lstrip('/')
        script = self.getProperty('validate_script')

        # Step 1: check transaction
        if email != account_email:
            raise RuntimeError, "Receiver email is not valid " + email

        # Step 2: resubmit the form to paypal, and see if paypal validate it
        params = {  }
        for key, value in request.form.items():
            params[key] = value
        params['cmd'] = '_notify-validate'
        params = urllib.urlencode(params)
        headers = {"Content-type": "application/x-www-form-urlencoded" }
        
        req = urllib2.Request("%s://%s/%s" % (scheme, domain, path), params,
                              headers)
        conn = urllib2.urlopen(req)
        data = conn.read()
        
        if not 'VERIFIED' in data:
            raise RuntimeError, "Paypal didn't verify transaction (return is %s)" % data
        
        # Step 3: prepare call to callback
        script = getattr(portal, script)
        if not custom:
            custom = invoice

        # Create Manager security context
        tmp_user = UnrestrictedUser('manager', '', ['Manager'], '')
        tmp_user = tmp_user.__of__(self.acl_users) # or use appropriate context
        old_sm = getSecurityManager()
        try:
            newSecurityManager(None, tmp_user)
            script(verification_key=self._makeVerificationKey(custom), payment_info=dict(request.form.items()))
        finally:
            setSecurityManager(old_sm)

    security.declarePublic('checkVerificationKey')
    def checkVerificationKey(self, item, key):
        """Check if key and invoice number match"""
        return key == self._makeVerificationKey(item)

    security.declarePrivate("_makeVerificationKey")
    def _makeVerificationKey(self, item):
        """Make a verification key"""
        hash_func = sha
        key = base64.decodestring(self.getProperty('tool_key'))
        sig_gen = hmac.new(key, item, hash_func)
        return base64.encodestring(sig_gen.digest())


    security.declareProtected("Manage portal", "manage_edit")
    def manage_edit(self, REQUEST):
        """ Change configuration """

        for key in ['paypal_url_scheme','paypal_domain',
                    'paypal_path','paypal_account_email',
                    'validate_script','default_currency',
                    'default_return_path','default_cancel_path',
                    'paypal_button_image','paypal_button_alt']:
            if REQUEST.has_key(key):
                self._updateProperty(key, REQUEST[key])

        REQUEST.RESPONSE.redirect(self.absolute_url()+'/paypal_prefs?portal_status_message=Saved%20configuration.')
